#define NUM_TEXTURES 1
#define GLI_FOG_MODE_LINEAR 0
#define GLI_FOG_MODE_EXP 1
#define GLI_FOG_MODE_EXP2 2

uniform vec4 light_position[1];
uniform vec4 light_ambient_color[1];
uniform vec4 light_diffuse_color[1];
uniform vec4 light_specular_color[1];
uniform vec3 light_spot_direction[1];
uniform vec3 light_attenuation_factors[1];
uniform float light_spot_exponent[1];
uniform float light_spot_cutoff_angle[1];
uniform bool light_compute_distance_attenuation[1];

uniform vec4 material_ambient_color;
uniform vec4 material_diffuse_color;
uniform vec4 material_specular_color;
uniform vec4 material_emissive_color;
uniform float material_specular_exponent;


const float c_zero = 0.0;
const float c_one = 1.0;
const int indx_zero = 0;
const int indx_one = 1;
uniform mat4 mvp_matrix; 
uniform mat4 modelview_matrix; 
uniform mat3 normal_matrix; 

uniform bool light_enable_state[1]; 
uniform bool enable_lighting; 
uniform bool light_model_two_sided; 
uniform bool enable_color_material; 

uniform vec4 obj_Color;

uniform float fog_density;
uniform float fog_start, fog_end;
uniform int fog_mode; 


uniform bool is_GPUBufferObject;

uniform float LightRate;	//

uniform bool is_HighLight;	//Ƿʾ

uniform bool enable_texcoord[NUM_TEXTURES]; 

attribute vec4 a_position; 
attribute vec2 a_texcoord0;
attribute vec2 a_texcoord1;
attribute vec4 a_color;
attribute vec3 a_normal; 

varying vec2 v_texcoord[NUM_TEXTURES];
varying vec4 v_front_color;
varying vec4 v_back_color;


vec4 p_eye;
vec3 n;
vec4 mat_ambient_color;
vec4 mat_diffuse_color;

varying float posz;
varying float v_fog_factor;

void main(void)
{
	{
		p_eye = modelview_matrix * a_position;
	}

	if(enable_lighting)
	{
		n = normal_matrix * a_normal;
		n = normalize(n);
		mat_ambient_color =  material_ambient_color;
		mat_diffuse_color = material_diffuse_color;
		
		{
				vec4 computed_color = vec4(c_zero, c_zero, c_zero, c_zero);
				vec3 h_vec;
				float ndotl, ndoth;
				float att_factor;
				att_factor = c_one;
				vec3 VPpli = light_position[0].xyz;
				
				{
					computed_color += (light_ambient_color[0] * mat_ambient_color);
					ndotl = max(c_zero, dot(n, VPpli));
					computed_color += (ndotl * light_diffuse_color[0] * mat_diffuse_color);
					h_vec = normalize(VPpli + vec3(c_zero, c_zero, c_one));
					ndoth = dot(n, h_vec);
					if (ndoth > c_zero)
					{
						//computed_color += (pow(ndoth, material_specular_exponent) * material_specular_color * light_specular_color[i]);
						computed_color += (ndoth * material_specular_color * light_specular_color[0]);
					}
					computed_color *= att_factor;
					v_back_color=computed_color;
					
					//v_back_color=vec4(1.0,1.0,1.0,1.0);
				}
		}
	}
	else
	{
	
		v_back_color=vec4(1.0,1.0,1.0,1.0);
	}
	
	//v_back_color=vec4(1.0,1.0,1.0,1.0);
		
	{
		v_texcoord[indx_zero] = a_texcoord0.xy;
	}

	v_back_color.xyz*=obj_Color.xyz*LightRate;

	if (is_HighLight)
  {
       v_back_color.xyz*=vec3(2.0,2.0,0.0);
  }
	
	v_back_color.w=1.0;
	gl_Position = mvp_matrix * a_position;
    	
	posz=gl_Position.w;
}
